<template>
  <input
    v-model.number="value"
    type="range"
    step="0.005"
    min="0"
    max="1"
  >
</template>

<script lang="ts">
import { Vue, Component, Model, Watch } from 'vue-property-decorator'

function round (precision) {
  const factor = Math.pow(10, precision)
  return x => Math.round(x * factor) / factor
}

@Component
export default class LogarithmicRange extends Vue {
  @Model('result') result: number

  value: number = Math.log10(9 * this.result + 1)

  @Watch('value')
  onValueChanged () {
    this.$emit('result', round(3)((Math.pow(10, this.value) - 1) / 9 / 20))
  }
}
</script>
